/// <reference types="backbone" />
import { OutputAreaModel, OutputArea } from '@jupyterlab/outputarea';
import { KernelMessage, Session } from '@jupyterlab/services';
import { Panel } from '@lumino/widgets';
import { NotebookWidgetManager } from './manager';
import * as outputBase from '@jupyter-widgets/output';
export declare const OUTPUT_WIDGET_VERSION = "1.0.0";
export declare class OutputModel extends outputBase.OutputModel {
    defaults(): Backbone.ObjectHash;
    initialize(attributes: any, options: any): void;
    /**
     * Register a new kernel
     */
    _handleKernelChanged({ oldValue, }: Session.ISessionConnection.IKernelChangedArgs): void;
    /**
     * Reset the message id.
     */
    reset_msg_id(): void;
    add(msg: KernelMessage.IIOPubMessage): void;
    clear_output(wait?: boolean): void;
    get outputs(): OutputAreaModel;
    setOutputs(model?: any, value?: any, options?: any): void;
    widgetManager: NotebookWidgetManager;
    private _msgHook;
    private _outputs;
}
export declare class OutputView extends outputBase.OutputView {
    _createElement(tagName: string): HTMLElement;
    _setElement(el: HTMLElement): void;
    /**
     * Called when view is rendered.
     */
    render(): void;
    remove(): any;
    model: OutputModel;
    _outputView: OutputArea;
    luminoWidget: Panel;
}
