import { DisposableDelegate } from '@lumino/disposable';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { DocumentRegistry, Context } from '@jupyterlab/docregistry';
import { INotebookModel, INotebookTracker, NotebookTracker } from '@jupyterlab/notebook';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { Kernel } from '@jupyterlab/services';
import { WidgetRenderer } from './renderer';
import { BundledIPyWidgets, ExternalIPyWidgets } from '../../../components/notebook/Notebook';
import * as base from '@jupyter-widgets/base';
export declare function registerWidgetManager(context: DocumentRegistry.IContext<INotebookModel>, rendermime: IRenderMimeRegistry, kernelConnection: Kernel.IKernelConnection | null, renderers: IterableIterator<WidgetRenderer>, app?: JupyterFrontEnd): DisposableDelegate;
export declare const registerExternalIPyWidgets: (context: Context<INotebookModel>, notebookTracker: NotebookTracker, ipywidgets: ExternalIPyWidgets[], kernelConnection: Kernel.IKernelConnection | null, app?: JupyterFrontEnd) => void;
export declare const registerBundledIPyWidgets: (context: Context<INotebookModel>, notebookTracker: NotebookTracker, ipywidgets: BundledIPyWidgets[], kernelConnection: Kernel.IKernelConnection | null, app?: JupyterFrontEnd) => void;
/**
 * The widget manager provider.
 */
export declare const iPyWidgetsPlugin: {
    activate: typeof activateIPyWidgetExtension;
};
/**
 * Activate the widget extension.
 */
declare function activateIPyWidgetExtension(rendermime: IRenderMimeRegistry, tracker: INotebookTracker, kernelConnection: Kernel.IKernelConnection | null, app?: JupyterFrontEnd): base.IJupyterWidgetRegistry;
/**
 * The base widgets.
 */
export declare const baseWidgetsPlugin: {
    activate: (registry: base.IJupyterWidgetRegistry) => void;
};
/**
 * The control widgets.
 */
export declare const controlWidgetsPlugin: {
    activate: (registry: base.IJupyterWidgetRegistry) => void;
};
/**
 * The output widget.
 */
export declare const outputWidgetPlugin: {
    activate: (registry: base.IJupyterWidgetRegistry) => void;
};
declare const _default: ({
    activate: typeof activateIPyWidgetExtension;
} | {
    activate: (registry: base.IJupyterWidgetRegistry) => void;
})[];
export default _default;
