import { Signal } from '@lumino/signaling';
import { IOutput } from '@jupyterlab/nbformat';
import { IOutputAreaModel } from '@jupyterlab/outputarea';
import { Kernel, KernelMessage } from '@jupyterlab/services';
export type IOPubMessageHook = (msg: KernelMessage.IIOPubMessage) => boolean | PromiseLike<boolean>;
export type ShellMessageHook = (msg: KernelMessage.IShellMessage) => boolean | PromiseLike<boolean>;
export type ExecutionResult = {
    future: Kernel.IFuture<KernelMessage.IExecuteRequestMsg, KernelMessage.IExecuteReplyMsg> | undefined;
    executor: KernelExecutor;
};
export declare class KernelExecutor {
    private _kernelConnection;
    private _outputs;
    private _outputsChanged;
    private _model;
    private _modelChanged;
    private _executeReplyReceived;
    private _future?;
    private _shellMessageHooks;
    private _executed;
    private _executedResolve;
    constructor(kernelConnection: Kernel.IKernelConnection);
    execute(code: string, iopubMessageHooks?: IOPubMessageHook[], shellMessageHooks?: ShellMessageHook[]): ExecutionResult;
    private _onIOPub;
    private _onReply;
    registerIOPubMessageHook: (msg: IOPubMessageHook) => void;
    get executed(): Promise<IOutputAreaModel>;
    get future(): Kernel.IFuture<KernelMessage.IExecuteRequestMsg, KernelMessage.IExecuteReplyMsg> | undefined;
    set future(value: Kernel.IFuture<KernelMessage.IExecuteRequestMsg, KernelMessage.IExecuteReplyMsg> | undefined);
    get result(): Promise<string>;
    get outputs(): IOutput[];
    get outputsChanged(): Signal<KernelExecutor, IOutput[]>;
    get model(): IOutputAreaModel;
    get modelChanged(): Signal<KernelExecutor, IOutputAreaModel>;
    get executeReplyReceived(): Signal<KernelExecutor, IOutputAreaModel>;
    get done(): Promise<KernelMessage.IExecuteReplyMsg>;
}
export default KernelExecutor;
